-- use command db2 -td# -vf tklmsql-fp.db2 to run this script individually.

-------------------------------------- CREATE TABLES ---------------------------------------
-- use command db2 -td# -vf tklmsql-fp.db2 to run this script individually.


-- These changes have been made to change timestamp columns to UTC Timezone.
-------------------------------------- BEGIN CREATE TABLESPACES ----------------------------
CREATE PROCEDURE CONVERT_TO_UTC(IN Table_Name varchar(50), IN ColumnToAdd varchar(50), IN ColumnToReplace varchar(50), IN ColumnConstraint varchar(50))
BEGIN
DECLARE statement1 NVARCHAR(500);
DECLARE statement2 NVARCHAR(500);
DECLARE statement3 NVARCHAR(500);
DECLARE statement4 NVARCHAR(500);
DECLARE statement5 NVARCHAR(500);

IF ColumnConstraint='NOT NULL' 
THEN SET statement1 = 'ALTER TABLE ' || Table_Name || ' ADD COLUMN ' || ColumnToAdd || ' TIMESTAMP ' || ColumnConstraint || ' DEFAULT CURRENT TIMESTAMP' ;
ELSE 
SET statement1 = 'ALTER TABLE ' || Table_Name || ' ADD COLUMN ' || ColumnToAdd || ' TIMESTAMP ' || ColumnConstraint;

END IF;


SET statement2 = 'REORG TABLE ' || Table_Name;
SET statement3 = 'UPDATE ' || Table_Name || ' SET ' || ColumnToAdd || '=' || ColumnToReplace || ' - CURRENT TIMEZONE';
SET statement4 = 'ALTER TABLE ' || Table_Name || ' DROP COLUMN ' || ColumnToReplace;
SET statement5 = 'ALTER TABLE ' || Table_Name || ' RENAME COLUMN ' || ColumnToAdd || ' TO ' || ColumnToReplace;
IF EXISTS(
select * from SYSIBM.syscolumns where tbname='KMT_MM_INSTANCE' and name='LAST_UPDATE_TIMESTAMP' and GENERATED='D'
)THEN


EXECUTE IMMEDIATE(statement1);
CALL SYSPROC.ADMIN_CMD(statement2);
EXECUTE IMMEDIATE(statement3);
EXECUTE IMMEDIATE(statement4);
EXECUTE IMMEDIATE(statement5);
CALL SYSPROC.ADMIN_CMD(statement2);

END IF;

END
#

CALL CONVERT_TO_UTC( 'KMT_METADATA' ,'TEMP_TIMESTAMP1' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_POLICY' ,'TEMP_TIMESTAMP2' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEYPOLICY_RN' ,'TEMP_TIMESTAMP3' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERPOLICY_RN' ,'TEMP_TIMESTAMP4' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEYSTR' ,'TEMP_TIMESTAMP5' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_GROUP_MEMBERS' ,'TEMP_TIMESTAMP6' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_TEMPL' ,'TEMP_TIMESTAMP7' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_DEVICE' ,'TEMP_TIMESTAMP8' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_DEVICE' ,'TEMP_DEVICEPENDINGDATE' , 'DEVICEPENDINGDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_DEVICE_TYPE' ,'TEMP_TIMESTAMP9' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_DEVICE_TYPE_ATTRIBUTES' ,'TEMP_TIMESTAMP10' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERTSTR_RN' ,'TEMP_TIMESTAMP11' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEYSTR_RN' ,'TEMP_TIMESTAMP12' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_GROUP' ,'TEMP_TIMESTAMP13' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_GROUP' ,'TEMP_INITIALIZATIONDATE' , 'INITIALIZATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_GROUP' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_DEVAUDIT' ,'TEMP_TIMESTAMP14' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_DEVAUDIT' ,'TEMP_TIME_STAMP' , 'TIME_STAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MACHINE' ,'TEMP_TIMESTAMP15' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MACHINE_DEVICE' ,'TEMP_TIMESTAMP16' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MACHINE_DEVICE' ,'TEMP_PENDING_DATE' , 'PENDING_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_APPINFO' ,'TEMP_TIMESTAMP17' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_CERTSUBJECT' ,'TEMP_TIMESTAMP18' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_CERTISSUER' ,'TEMP_TIMESTAMP19' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_CRYPTOPARAMS' ,'TEMP_TIMESTAMP20' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_CUSTOM' ,'TEMP_TIMESTAMP21' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_DIGEST' ,'TEMP_TIMESTAMP22' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_LINK' ,'TEMP_TIMESTAMP23' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_GLOBAL_NAMES' ,'TEMP_TIMESTAMP24' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_NAME' ,'TEMP_TIMESTAMP25' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_OBJECTGROUP' ,'TEMP_TIMESTAMP26' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_ATTR_ALTERNATIVE_NAME' ,'TEMP_TIMESTAMP27' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CLIENT' ,'TEMP_TIMESTAMP28' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CLIENT_KEY_CERT_LIST' ,'TEMP_TIMESTAMP29' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_NOTIFICATIONS' ,'TEMP_TIMESTAMP30' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_NOTIFICATIONS' ,'TEMP_TIMESTAMP_LAST_NOTIFY' , 'TIMESTAMP_LAST_NOTIFY' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_NOTIFICATION_POLICY' ,'TEMP_TIMESTAMP31' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_LICENSE' ,'TEMP_TIMESTAMP32' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_LICENSE' ,'TEMP_CREATIONTIME' , 'CREATIONTIME' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_BACKUP' ,'TEMP_TIMESTAMP33' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_BACKUP' ,'TEMP_LASTBACKUPDATE' , 'LASTBACKUPDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_OBJECT' ,'TEMP_TIMESTAMP34' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_CLIENT_ENCRYPT_DECRYPT' ,'TEMP_TIMESTAMP35' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY_GROUPS' ,'TEMP_TIMESTAMP36' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY_GROUP_MEMBERS' ,'TEMP_TIMESTAMP37' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_EXPORT_KEYGROUP_SUMMARY' ,'TEMP_TIMESTAMP38' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_EXPORT_KEYGROUP_SUMMARY' ,'TEMP_START_TIME' , 'START_TIME' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_EXPORT_KEYGROUP_SUMMARY' ,'TEMP_END_TIME' , 'END_TIME' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MM_INSTANCE_STATUS' ,'TEMP_TIMESTAMP40' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MM_INSTANCE_STATUS' ,'TEMP_TIME' , 'TIME' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MM_AGENT_TRUSTSTORE' ,'TEMP_TIMESTAMP41' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_CREATIONDATE' , 'CREATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_EXPIRATIONDATE' , 'EXPIRATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_RETIREDATE' , 'RETIREDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_DESTROYDATE' , 'DESTROYDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_COMPROMISEDATE' , 'COMPROMISEDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_ARCHIVETIME' , 'ARCHIVETIME' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_LAST_CHANGED_DATE' , 'LAST_CHANGED_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_COMPROMISE_OCCURRENCE_DATE' , 'COMPROMISE_OCCURRENCE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_PROCESS_START_DATE' , 'PROCESS_START_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_PROTECT_STOP_DATE' , 'PROTECT_STOP_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KEY' ,'TEMP_ORIGINAL_CREATION_DATE' , 'ORIGINAL_CREATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_CREATIONDATE' , 'CREATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_EXPIRATIONDATE' , 'EXPIRATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_DESTROYDATE' , 'DESTROYDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_COMPROMISEDATE' , 'COMPROMISEDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_RETIREDATE' , 'RETIREDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_ARCHIVETIME' , 'ARCHIVETIME' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_LAST_CHANGED_DATE' , 'LAST_CHANGED_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_COMPROMISE_OCCURRENCE_DATE' , 'COMPROMISE_OCCURRENCE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_PROCESS_START_DATE' , 'PROCESS_START_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_PROTECT_STOP_DATE' , 'PROTECT_STOP_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_PENDING_TRUST_DATE' , 'PENDING_TRUST_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CERT' ,'TEMP_ORIGINAL_CREATION_DATE' , 'ORIGINAL_CREATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_ARCHIVE_DATE' , 'ARCHIVE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_LAST_CHANGED_DATE' , 'LAST_CHANGED_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_INITIAL_DATE' , 'INITIAL_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_DESTROYDATE' , 'DESTROYDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_ORIGINAL_CREATION_DATE' , 'ORIGINAL_CREATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_DEACTIVATION_DATE' , 'DEACTIVATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_COMPROMISE_OCCURRENCE_DATE' , 'COMPROMISE_OCCURRENCE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_OPAQUE' ,'TEMP_COMPROMISE_DATE' , 'COMPROMISE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_DEACTIVATION_DATE' , 'DEACTIVATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_ARCHIVE_DATE' , 'ARCHIVE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_INITIAL_DATE' , 'INITIAL_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_LAST_CHANGED_DATE' , 'LAST_CHANGED_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_DESTROYDATE' , 'DESTROYDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_COMPROMISE_OCCURRENCE_DATE' , 'COMPROMISE_OCCURRENCE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_COMPROMISEDATE' , 'COMPROMISEDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_SECRET_DATA' ,'TEMP_ORIGINAL_CREATION_DATE' , 'ORIGINAL_CREATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_INITIAL_DATE' , 'INITIAL_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_DESTROYDATE' , 'DESTROYDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_ARCHIVE_DATE' , 'ARCHIVE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_LAST_CHANGED_DATE' , 'LAST_CHANGED_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_PROCESS_START_DATE' , 'PROCESS_START_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_PROTECT_STOP_DATE' , 'PROTECT_STOP_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_DEACTIVATION_DATE' , 'DEACTIVATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE' ,'TEMP_ORIGINAL_CREATION_DATE' , 'ORIGINAL_CREATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_INITIAL_DATE' , 'INITIAL_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_ACTIVATIONDATE' , 'ACTIVATIONDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_DESTROYDATE' , 'DESTROYDATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_ARCHIVE_DATE' , 'ARCHIVE_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_LAST_CHANGED_DATE' , 'LAST_CHANGED_DATE' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_PROCESS_START_DATE' , 'PROCESS_START_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_PROTECT_STOP_DATE' , 'PROTECT_STOP_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_KMIP_OBJECT_TEMPLATE_BODY' ,'TEMP_DEACTIVATION_DATE' , 'DEACTIVATION_DATE' , 'NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CFGT_INSTDETAILS' ,'TEMP_GENERATEDTIME' , 'GENERATEDTIME' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_CONFLICT_CHANGES' ,'TEMP_CHANGED_TIME' , 'CHANGED_TIME' , 'NOT NULL' )
#
CALL CONVERT_TO_UTC( 'KMT_MM_INSTANCE' ,'TEMP_TIMESTAMP39' , 'LAST_UPDATE_TIMESTAMP' , 'NULL' )
#

DROP PROCEDURE CONVERT_TO_UTC
#

COMMIT
#

CREATE OR REPLACE PROCEDURE CREATEWRAPDATATABLE

BEGIN

IF NOT EXISTS(
select 1 from SYSIBM.systables WHERE name='KMT_KMIP_WRAPDATA'
)THEN
EXECUTE IMMEDIATE 'CREATE TABLE KMT_KMIP_WRAPDATA (
	MANAGED_OBJECT_UUID VARCHAR(64) NOT NULL,
	MACSIGN_KEY_UUID VARCHAR(64),
	WRAP_KEY_UUID VARCHAR(64),
	BLOCK_CIPHER_MODE INTEGER,
	PADDING_METHOD INTEGER,
	HASHING_ALGORITHM INTEGER,
	WRAPPING_METHOD INTEGER,
	ENCODING_OPTIONS INTEGER,
	MAC_SIGNATURE VARCHAR(256) FOR BIT DATA,
	RANDOM_IV VARCHAR(256) FOR BIT DATA,
	foreign key(MANAGED_OBJECT_UUID) references KMT_KEY(UUID),
	foreign key(MACSIGN_KEY_UUID) references KMT_KEY(UUID),
	foreign key(WRAP_KEY_UUID) references KMT_KEY(UUID)
)
IN TKLM_DATA_SM INDEX IN TKLM_4K_IDX
DATA CAPTURE NONE ' ;

EXECUTE IMMEDIATE 'CREATE TABLE KMT_CHANGESET_TRACK (
	OBJECT_TYPE VARCHAR(64),
	NAME VARCHAR(64),
	UUID VARCHAR(64),
	REF_TABLE_NAME  VARCHAR(64) NOT NULL,    
	REF_UUID  VARCHAR(64),
	REF_NAME_ALIAS  VARCHAR(512),
	OPERATION_TYPE  SMALLINT NOT NULL,
	CREATION_TIMESTAMP  TIMESTAMP NOT NULL,
	LAST_UPDATE_TIMESTAMP  TIMESTAMP NOT NULL
)  
IN TKLM_DATA_LG INDEX IN TKLM_4K_IDX
DATA CAPTURE NONE ' ;

EXECUTE IMMEDIATE 'CREATE TABLE KMT_KMIP_ATTR_HSMATTRIBUTES (
	MANAGED_OBJECT_UUID VARCHAR(64) NOT NULL,
	OBJECT_TYPE VARCHAR(64),
	SENSITIVE SMALLINT,
	ALWAYS_SENSITIVE SMALLINT,
	EXTRACTABLE SMALLINT,
	NEVER_EXTRACTABLE SMALLINT,
	PKCS12_FRIENDLY_NAME VARCHAR(64),
	SHORT_UNIQUE_IDENTIFIER VARCHAR(64),
	LAST_UPDATE_TIMESTAMP TIMESTAMP NOT NULL
)
IN TKLM_DATA_SM INDEX IN TKLM_4K_IDX
DATA CAPTURE NONE ' ;

END IF;

END	
#

CALL CREATEWRAPDATATABLE
#

DROP PROCEDURE CREATEWRAPDATATABLE
#

COMMIT
#

CREATE PROCEDURE ALTER_30FP_DB_CRYPTOPARAMS
BEGIN

	IF NOT EXISTS(
		select * from SYSIBM.syscolumns where tbname='KMT_KMIP_ATTR_CRYPTOPARAMS' and name='SALT_LENGTH'
	)THEN
		EXECUTE IMMEDIATE 'ALTER TABLE KMT_KMIP_ATTR_CRYPTOPARAMS ADD COLUMN SALT_LENGTH INTEGER';
	END IF;

	IF NOT EXISTS(
		select * from SYSIBM.syscolumns where tbname='KMT_KMIP_ATTR_CRYPTOPARAMS' and name='P_SOURCE'
	)THEN
		EXECUTE IMMEDIATE 'ALTER TABLE KMT_KMIP_ATTR_CRYPTOPARAMS ADD COLUMN P_SOURCE VARCHAR(256)';
	END IF;

	IF NOT EXISTS(
		select * from SYSIBM.syscolumns where tbname='KMT_KMIP_ATTR_CRYPTOPARAMS' and name='MASK_GENERATOR'
	)THEN
		EXECUTE IMMEDIATE 'ALTER TABLE KMT_KMIP_ATTR_CRYPTOPARAMS ADD COLUMN MASK_GENERATOR INTEGER';
	END IF;

	IF NOT EXISTS(
		select * from SYSIBM.syscolumns where tbname='KMT_KMIP_ATTR_CRYPTOPARAMS' and name='MASK_GENERATOR_HASHING_ALGO'
	)THEN
		EXECUTE IMMEDIATE 'ALTER TABLE KMT_KMIP_ATTR_CRYPTOPARAMS ADD COLUMN MASK_GENERATOR_HASHING_ALGO INTEGER';
	END IF;

END
#

CALL ALTER_30FP_DB_CRYPTOPARAMS()
#

DROP PROCEDURE ALTER_30FP_DB_CRYPTOPARAMS
#

CREATE OR REPLACE PROCEDURE INSERTEDIFDATA

BEGIN
	IF NOT EXISTS(
		select * from KMT_DEVICE_TYPE where UUID = 14 and NAME = 'PEER_TO_PEER'
	)THEN
		INSERT INTO KMT_DEVICE_TYPE(UUID,BASE_FAMILY_ID,VERSION,NAME,
		ROLE_NAME) VALUES(14,14,0,'PEER_TO_PEER','PEER_TO_PEER');	
		
		INSERT INTO KMT_KEY_GROUPS(UUID, NAME, KEY_GROUP_TYPE, REF_IDENTIFIER, DESCRIPTION) VALUES(14,'PEER_TO_PEER',0,14,'PEER_TO_PEER KEY GROUP');	
				
		INSERT INTO KMT_DEVICE_TYPE_ATTRIBUTES (ATTR_NAME,ATTR_VALUE,DEVICE_TYPE_ID,
		UUID) VALUES ('enableKMIPDelete', '0', 14, 'DEVTYPEATTR-25');
		
		INSERT INTO KMT_DEVICE_TYPE_ATTRIBUTES (ATTR_NAME,ATTR_VALUE,DEVICE_TYPE_ID,
		UUID) VALUES ('AddNewCertsToPending', 'false', 14, 'DEVTYPEATTR-26');
		
	END IF;

END
#
	
CALL INSERTEDIFDATA()
#

DROP PROCEDURE INSERTEDIFDATA
#
	
CREATE OR REPLACE PROCEDURE INSERTDS8K_TCT_DATA

BEGIN
	IF NOT EXISTS(
		select * from KMT_DEVICE_TYPE where UUID = 15 and NAME = 'DS8000_TCT'
	)THEN
		INSERT INTO KMT_DEVICE_TYPE(UUID,BASE_FAMILY_ID,VERSION,NAME,
		ROLE_NAME) VALUES(15,12,0,'DS8000_TCT','DS8000_TCT');	
		
		INSERT INTO KMT_KEY_GROUPS(UUID, NAME, KEY_GROUP_TYPE, REF_IDENTIFIER, DESCRIPTION) VALUES(15,'DS8000_TCT',0,12,'DS8000_TCT KEY GROUP');
						
		INSERT INTO KMT_DEVICE_TYPE_ATTRIBUTES (ATTR_NAME,ATTR_VALUE,DEVICE_TYPE_ID,
		UUID) VALUES ('enableKMIPDelete', '0', 15, 'DEVTYPEATTR-27');
		
		INSERT INTO KMT_DEVICE_TYPE_ATTRIBUTES (ATTR_NAME,ATTR_VALUE,DEVICE_TYPE_ID,
		UUID) VALUES ('AddNewCertsToPending', 'false', 15, 'DEVTYPEATTR-28');
		
	END IF;
END
#
	
CALL INSERTDS8K_TCT_DATA()
#

DROP PROCEDURE INSERTDS8K_TCT_DATA
#
		