@echo OFF

rem #############################################################################
rem #
rem #
rem # 
rem # ===========================================================================
rem # Licensed Materials - Property of IBM
rem #
rem # (C) Copyright IBM Corp. 2016.  All Rights Reserved
rem #
rem # US Government Users Restricted Rights - Use, duplication, or
rem # disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem #  ===========================================================================
rem # 
rem #############################################################################

:: Keep variables local
SETLOCAL


if [%1]==[] goto usage
if [%2]==[] goto usage
if [%3]==[] goto usage
if [%4]==[] goto usage
SET IM_INSTALL_LOCATION=%1
SET WAS_INSTALL_LOCATION=%2
SET WAS_USER=%3
SET WAS_PASS=%4
SET SKLM_STATUS_FILE=%systemdrive%%homepath%/SKLMFPInstallStatus.properties

if not exist %WAS_INSTALL_LOCATION% (
	@echo Check if the parameter WAS_INSTALL_LOCATION is set to the valid WAS directory
	echo STATUS=1 > %SKLM_STATUS_FILE%
	goto end
)

if not exist %WAS_INSTALL_LOCATION%\bin\stopServer.bat (
	@echo Check if the parameter WAS_INSTALL_LOCATION is set to the valid WAS directory
	echo STATUS=1 > %SKLM_STATUS_FILE%
	goto end
)

if not exist %IM_INSTALL_LOCATION% (
	@echo Check if the parameter IM_INSTALL_LOCATION is set to the valid IM directory
	echo STATUS=1 > %SKLM_STATUS_FILE%
	goto end
)

if not exist %IM_INSTALL_LOCATION%\eclipse\tools\imcl.exe (
	@echo Check if the parameter IM_INSTALL_LOCATION is set to the valid IM directory
	echo STATUS=1 > %SKLM_STATUS_FILE%
	goto end
)

if not exist %IM_INSTALL_LOCATION%\eclipse\IBMIM.exe (
	@echo Check if the parameter IM_INSTALL_LOCATION is set to the valid IM directory
	echo STATUS=1 > %SKLM_STATUS_FILE%
	goto end
)


echo About to install FixPack...

call %WAS_INSTALL_LOCATION%\bin\wsadmin.bat -lang jython -conntype None -profileName KLMProfile -tracefile %cd%/wsadmin.log -appendtrace true -username %WAS_USER% -password %WAS_PASS% -c "AdminConfig.create('Property', '(cells/SKLMCell/nodes/SKLMNode/servers/server1|server.xml#SessionManager_1183122130078)', '[[validationExpression \"\"] [name \"InvalidateOnUnauthorizedSessionRequestException\"] [description \"\"] [value \"true\"] [required \"false\"]]')" >> wsadmin.log

call %WAS_INSTALL_LOCATION%\bin\wsadmin.bat -lang jython -conntype None -profileName KLMProfile -tracefile %cd%/wsadmin.log -appendtrace true -username %WAS_USER% -password %WAS_PASS% -c "AdminConfig.save()"  >> wsadmin.log

echo STATUS=2 > %SKLM_STATUS_FILE%
echo Stopping SKLM Server...
echo %WAS_INSTALL_LOCATION%\bin\stopServer.bat server1 -profileName KLMProfile -username %WAS_USER% -password ******
call %WAS_INSTALL_LOCATION%\bin\stopServer.bat server1 -profileName KLMProfile -username %WAS_USER% -password %WAS_PASS%
echo STATUS=2 > %SKLM_STATUS_FILE%
echo Launching InstallManager...
echo %IM_INSTALL_LOCATION%\eclipse\IBMIM.exe -input %cd%/sklm/SKLM_Silent_Update_Win_Resp.xml -silent -acceptLicense
%IM_INSTALL_LOCATION%\eclipse\IBMIM.exe -input %cd%/sklm/SKLM_Silent_Update_Win_Resp.xml -silent -acceptLicense

set el1=%ERRORLEVEL%
IF %el1% == 0 (
		echo STATUS=0 > %SKLM_STATUS_FILE%
		echo Installation of fix pack is complete. See the Installation Manager log files for more information.) ELSE (
		echo STATUS=1 > %SKLM_STATUS_FILE% 
		echo Installation of the fix pack is failed. See the Installation Manager log files for more information.)

goto end


:usage

@echo *************************************************************
@echo Usage: 
@echo        silent_updateSKLM.bat IM_INSTALL_LOCATION WAS_INSTALL_LOCATION WAS_ADMIN WAS_PASSWORD
@echo        where
@echo        IM_INSTALL_LOCATION is the directory where Installation manager for SKLM is installed.
@echo        WAS_INSTALL_LOCATION is the directory where WebSphere Application Server(WAS) for SKLM is installed.
@echo        WAS_ADMIN is Username of WebSphere Application Server(WAS) for SKLM.
@echo        WAS_PASSWORD is Password of WebSphere Application Server(WAS) for SKLM.
@echo Example : 
@echo 		silent_updateSKLM.bat "C:\Program Files\IBM\Installation Manager" 
@echo			"C:\Program Files\IBM\WebSphere\AppServer" 
@echo			wasadmin 
@echo			wasadminpwd 
@echo Note : If value of parameters IM_INSTALL_LOCATION and WAS_INSTALL_LOCATION contains spaces, 
@echo		 please enclose it with quotes as shown in example.
@echo		 please ensure that the username/passwords in SKLM_Silent_Update_Win_Resp.xml is correct
@echo *************************************************************
echo STATUS=1 > %SKLM_STATUS_FILE%
goto end

:end
